#include<iostream>
#include<stdio.h>
#include<string.h>
#include<cmath>                
using namespace std;

//declaration of global variables
char input[10][50];
char stack[10][50];                  //used in infx to pstfx[abhi] conversion
char infix[10][50];                   //used to store the infx string formed frm input[abhi]
char pstfx[10][50];                  //used to store pstfx[abhi] string formed frm infx
float values[10][10]={};             //used to store constants present in the inpt string
float eval[10][10];                  //stack[abhi] used in eval[abhi]uation
int top1=-1;                      //index indicator of the char stack[abhi]
int top2=-1;                      //index indicator of the float stack[abhi] named eval[abhi]
int flag2=0;
int abhi=0;			  //it is incremented when the expression is not defined

//declaration of functions
void inpt_to_infx(); 
void in_to_post();   
void ch_push (char);                
void fl_push(float);                  
float fl_pop();                     
char ch_pop();                      
float evaluate(float x);        

int main()
{               //used to store the function entered as a string
    float x,y;
	printf("Enter the infix expression");
	cin>>input[abhi];
    inpt_to_infx();
    cout<<infix[abhi];                             
	in_to_post();
	cout<<pstfx[abhi];
	cout<<"enter x\n";
	cin>>x;
	y=evaluate(x);
	cout<<"The value of expression is  \n\n"<<y<<endl;
	abhi++;
	printf("Enter the infix expression");
	cin>>input[abhi];
    inpt_to_infx();
    cout<<infix[abhi];                             
	in_to_post();
	cout<<pstfx[abhi];
	cout<<"enter x\n";
	cin>>x;
	y=evaluate(x);
	cout<<"The value of expression is  \n\n"<<y<<endl;
	return 0;
}
//function to convert inpt to infx
//all the no are stored in an array & are replaced by their corresponding array index 
void inpt_to_infx(){
     int i,j=0,k=0;                //i,j & k keep track of input[abhi], infx and values[abhi] respectively
     float digit,value,m=1;
     for(i=0;input[abhi][i]!='\0';){
                              if(input[abhi][i]>=48 && input[abhi][i]<=57){//checks if input[abhi] is a digit indicating a constant
                                                 infix[abhi][j]=(char)(k+48);
                                                 j++;                   
                                                 while(input[abhi][i]>=48 && input[abhi][i]<=57){
                                                                  values[abhi][k]=values[abhi][k]*10+input[abhi][i]-48;
                                                                  i++;
                                                                  }
                                                k++;
                                                }
                                 else if(input[abhi][i]==46){//checks for a decimal point
                                                  if(input[abhi][i-1]>=48 && input[abhi][i-1]<=57){k--;j--;}
                                                  infix[abhi][j]=(char) (k+48);
                                                  j++;     
                                                  i++;
                                                  while(input[abhi][i]>=48 && input[abhi][i]<=57){
                                                                    value=pow(10,m);
                                                                    digit=(float)(input[abhi][i]-48); 
                                                                    values[abhi][k]=values[abhi][k]+digit/value;
                                                                    m++;
                                                                    i++;
                                                                    }
                                                  k++;
                                                  }
                                 else if(input[abhi][i]>=97 && input[abhi][i]<=122 && input[abhi][i-1]>=48 && input[abhi][i-1]<=57){
                                      infix[abhi][j]='*';
                                      j++;
                                      infix[abhi][j]=input[abhi][i];
                                      j++;
                                      i++;
                                      }
                                 else if(input[abhi][i]==45 && !((input[abhi][i-1]>=48 && input[abhi][i-1]<=57)||input[abhi][i-1]==120||input[abhi][i-1]==41)){
                                      values[abhi][k]=(-1);
                                      infix[abhi][j]=(char)(k+48);j++;
                                      infix[abhi][j]='*';j++;
                                      k++;
                                      i++;
                                      }
                                 else{
                                      infix[abhi][j]=input[abhi][i];
                                      j++;
                                      i++;
                                      }
                              }
     infix[abhi][j]='\0';
     }
//function to push a character in char stack[abhi]
void ch_push (char symb)            //function to push an operator into the top of the stack[abhi]
{
		if (top1>=49)         //top1 is the topmost index of stack[abhi] which is filled
	{
		printf("stack[abhi] overflow");
		getchar();
		return;
	}
	else
	{
		top1=top1+1;            //ch_push symbol into the next empty position
		stack[abhi][top1]=symb;
	}
}
//function to push a number in float stack[abhi]
void fl_push(float x)            //function to push an operator into the top of the stack[abhi]
{
	if (top2>=49)         //top2 is the topmost index of stack[abhi] which is filled
	{
		printf("stack[abhi] overflow");
		getchar();
		return;
	}
	else
	{
		top2=top2+1;            //ch_push symbol into the next empty position
		eval[abhi][top2]=x;
	}
}
//function to ch_pop a character from char stack[abhi]
char ch_pop()                                       //function to ch_pop out an operator out from the top of the stack[abhi]
{
	char item;
	if(top1==-1)                             //stack[abhi] contains symbols from index=0
	{
		printf("stack[abhi] empty");
		getchar();
		return(0);
	}
	else
	{
	 	item=stack[abhi][top1];                //ch_pop out topmost element
		top1--;
	}
	return(item);
}
 //function to pop a number from float stack[abhi]
float fl_pop()                              //function to ch_pop out an operator out from the top of the stack[abhi]
{
	float var;
	if(top2==-1)                         //stack[abhi] contains symbols from index=0
	{
		printf("stack[abhi] empty");
		getchar();
		return(0);
	}
	else
	{
	 	var=eval[abhi][top2];                //ch_pop out topmost element
		top2--;
	}
	return(var);
}

//define precedence order for various operators using ASCII codes
int preced(char ch)
{
    if(ch==115 || ch==99 || ch==116 || ch==105 || ch==111 || ch==97 || ch==110 || ch==108 || ch==101)
    {
        return(7);
    }                                                                     
	else if(ch==94)                         //ASCII code for ^
	{
		return(6);
	}
	else if(ch==47)                         //ASCII code for /
	{
		return(5);
	}
	else
	if(ch==42)                              //ASCII code for *
	{
		return(4);
	}
	else if(ch==45)                         //ASCII code for -
	{
		return(3);	
	}
	else if(ch==43)                        //ASCII code for +
		return(2);
 	else
		return(1);                         //any other character receives least precedence
}
//function to convert infx to pstfx[abhi]
/*infix[abhi] to Postfix Conversion :

In normal algebra we use the infix[abhi] notation like a+b*c. The corresponding postfix notation is abc*+. The algorithm for the conversion is as follows :

    * Scan the infix[abhi] string from left to right.
    * Initialise an empty stack[abhi].
    * If the scannned character is an operand, add it to the Postfix string. If the scanned character is an operator and if the stack[abhi] is empty Push the character to stack[abhi].
          o If the scanned character is an Operand and the stack[abhi] is not empty, compare the precedence of the character with the element on top of the stack[abhi] (topstack[abhi]). If topstack[abhi] has higher precedence over the scanned character Pop the stack[abhi] else Push the scanned character to stack[abhi]. Repeat this step as long as stack[abhi] is not empty and topstack[abhi] has precedence over the character.
      Repeat this step till all the characters are scanned.
    * (After all characters are scanned, we have to add any character that the stack[abhi] may have to the Postfix string.) If stack[abhi] is not empty add topstack[abhi] to Postfix string and Pop the stack[abhi]. Repeat this step as long as stack[abhi] is not empty.
    * Return the Postfix string. */

/*takes an infix[abhi] expression and converts it into an equivalent postfix expression*/

void in_to_post()
{
	int length;
	int index=0,pos=0;         
	char symbol,temp;
	length=strlen(infix[abhi]);
	ch_push('\0');                            //use # as sentry
	while(index<length)
	{
		symbol=infix[abhi][index];
		switch(symbol)
		{
			case'(':ch_push(symbol);         // directly ch_push '(' to top of stack[abhi]
			break;
			case')' :temp=ch_pop();          // ch_pop out all symbols between '(' and ')' 
			while(temp!='(')
			{
				pstfx[abhi][pos]=temp;
				pos++;
				temp=ch_pop();
			}
			break;
			case '+' :
			case '-' :
			case '*' :
			case '/' :
			case '^' :
            		case 's' :           //symbol for sin
            		case 'c' :           //symbol for cos
			case 't' :           //symbol for tan
            		case 'i' :           //symbol for cosec
            		case 'o' :           //symbol for sec
            		case 'a' :           //symbol for cot
            		case 'n' :           //symbol for ln
            		case 'l' :           //symbol for log
            		case 'e' :           //symbol for exponential
            			while (preced(stack[abhi][top1])>=preced(symbol))         //ch_push or ch_pop symbols depending on preference order
				{
					temp=ch_pop();
					pstfx[abhi][pos]=temp;
					pos++;
				}
				ch_push(symbol);
				break;
                        //array index no			
			case '0' :          
            		case '1' :      
            		case '2' :        
            		case '3' :        
            		case '4' :        
            		case '5' :        
            		case '6' :        
            		case '7' :        
            		case '8' :        
            		case '9' :
            		case 'x' :
            		case '\0':       
            			pstfx[abhi][pos++]=symbol;          //in case of non operators,add the operand to the postfix string
				break;
			default:cout<<"\n\nERROR\n\n";
				break;
		}
		index++;
	}
	//ch_pop out the remaining symbols and add them to the postfix string
	while(top1>0)
	{
		temp=ch_pop();
		pstfx[abhi][pos++]=temp;
	}
	pstfx[abhi][pos++]='\0';
}
//function to eval[abhi]uate the postfix expression 
/*In normal algebra we use the infix[abhi] notation like a+b*c. The corresponding postfix notation is abc*+. The algorithm for the conversion is as follows :

    * Scan the Postfix string from left to right.
    * Initialise an empty stack[abhi].
    * If the scannned character is an operand, add it to the stack[abhi]. If the scanned character is an operator, there will be atleast two operands in the stack[abhi].
          o If the scanned character is an Operator, then we store the top most element of the stack[abhi](topstack[abhi]) in a variable temp. Pop the stack[abhi]. Now eval[abhi]uate topstack[abhi](Operator)temp. Let the result of this operation be retVal. Pop the stack[abhi] and Push retVal into the stack[abhi].
      Repeat this step till all the characters are scanned.
    * After all characters are scanned, we will have only one element in the stack[abhi]. Return topstack[abhi].*/ 
float evaluate(float x){
      float f1,f2,f3,result;
      int z;
      for(int i=0;pstfx[abhi][i]!='\0';i++){
              switch (pstfx[abhi][i]){
                     case '0' :
                     case '1' :
                     case '2' :
                     case '3' :
                     case '4' :
                     case '5' :
                     case '6' :
                     case '7' :
                     case '8' :
                     case '9' :
                          z=(int)pstfx[abhi][i]-48;
                          f1=values[abhi][z];
                          fl_push(f1);
                          break;
                     case 'x' :
                          fl_push(x);
                          break;
                     case '+':
                          f2=fl_pop();
                          f1=fl_pop();
                          f3=f1+f2;
                          fl_push(f3);
                          break;
                     case '-':
                          f2=fl_pop();
                          f1=fl_pop();
                          f3=f1-f2;
                          fl_push(f3);
                          break;
                     case '*':
                          f2=fl_pop();
                          f1=fl_pop();
                          f3=f1*f2;
                          fl_push(f3);
                          break;
                     case '/':
                          f2=fl_pop();
                          f1=fl_pop();
                          f3=f1/f2;
                          fl_push(f3);
                          break;
                     case '^':
                          f2=fl_pop();
                          f1=fl_pop();
                          f3=pow(f1,f2);
                          fl_push(f3);
                          break;
                     case 's':
                          f1=fl_pop();
                          f2=sin(f1);
                          fl_push(f2);
                          break;
                     case 'c':
                          f1=fl_pop();
                          f2=cos(f1);
                          fl_push(f2);
                          break;
                     case 't':
                          f1=fl_pop();
                          f2=tan(f1);
                          fl_push(f2);
                          break;
                     case 'i':
                          f1=fl_pop();
                          f2=1/sin(f1);
                          fl_push(f2);
                          break;
                     case 'o':
                          f1=fl_pop();
                          f2=1/cos(f1);
                          fl_push(f2);
                          break;
                     case 'a':
                          f1=fl_pop();
                          f2=1/tan(f1);
                          fl_push(f2);
                          break;
                     case 'n':
                          f1=fl_pop();
			  f2=log(f1);
                          fl_push(f2);
                          break;
                     case 'l':
                          f1=fl_pop();
                          f2=log10(f1);
                          fl_push(f2);
                          break;
                     case 'e':
                          f1=fl_pop();
                          f2=exp(f1);
                          fl_push(f2);
                          break;
                     default :cout<<"\nERROR\n";
                     }
              }
              result=fl_pop();
	      if(result<500000 && result>(-500000)){
              				return result;
						}
	      else{
			flag2++;		
			return NULL;
			}      
	}
